diff -uwr source/scripts/tcw_player.cpp 4.0/source/scripts/tcw_player.cpp
--- source/scripts/tcw_player.cpp	2011-09-03 08:30:06.000000000 +0800
+++ 4.0/source/scripts/tcw_player.cpp	2011-10-15 12:39:38.266601500 +0800
@@ -591,6 +845,7 @@
 			}
 		}
 	}
+	}
 	else if (message == 1005)//Tech Composit Armor Upgrade complete
 	{
 		if (param == 1)
@@ -615,6 +870,19 @@
 	Auto_Save_Variable(&playdetected,sizeof(playdetected),3);
 	Auto_Save_Variable(&commandocurrpos,sizeof(commandocurrpos),4);
 	Auto_Save_Variable(&commandonewpos,sizeof(commandonewpos),5);
+	Auto_Save_Variable(&map_low_grav,sizeof(map_low_grav),6);
+	Auto_Save_Variable(&map_dm_tech1,sizeof(map_dm_tech1),7);
+	Auto_Save_Variable(&map_dm_tech2,sizeof(map_dm_tech2),8);
+	Auto_Save_Variable(&map_dm_tech3,sizeof(map_dm_tech3),9);
+	Auto_Save_Variable(&map_coop_gdi,sizeof(map_coop_gdi),10);
+	Auto_Save_Variable(&map_coop_nod,sizeof(map_coop_nod),11);
 }
 
+void tcw_I_Have_Ion_Cannon_Beacon::Destroyed(GameObject *obj)
+{
+	Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_Buy_Beacon_Ion"),100101,1,0);
+}
+
+
+ScriptRegistrant<tcw_I_Have_Ion_Cannon_Beacon> tcw_I_Have_Ion_Cannon_Beacon_Registrant("tcw_I_Have_Ion_Cannon_Beacon","");
 ScriptRegistrant<tcw_Grant_Powerup_Created> tcw_Grant_Powerup_Created_Registrant("tcw_Grant_Powerup_Created","Weapon1=TCW_POW_Knife:string,Weapon2=0:string,Weapon3=0:string,Weapon4=0:string,Weapon5=0:string");
\ No newline at end of file
diff -uwr source/scripts/tcw_player.h 4.0/source/scripts/tcw_player.h
--- source/scripts/tcw_player.h	2011-09-03 08:30:06.000000000 +0800
+++ 4.0/source/scripts/tcw_player.h	2011-10-15 12:39:38.271484300 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -11,16 +11,29 @@
 	with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
+
 class tcw_Grant_Powerup_Created : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj, int message, int param, GameObject *sender);
 	void Killed(GameObject *obj, GameObject *shooter);
 	public: void Register_Auto_Save_Variables();
+	bool isInitialized;
 	void Timer_Expired(GameObject *obj, int number);
 	int kills;
 	bool revealed;
 	bool playdetected;
 	bool upgrade_composit_armor_available;
+	bool map_low_grav;
+	bool map_dm_tech1;
+	bool map_dm_tech2;
+	bool map_dm_tech3;
+	bool map_coop_gdi;
+	bool map_coop_nod;
 	Vector3 commandocurrpos;
 	Vector3 commandonewpos;
 };
+
+class tcw_I_Have_Ion_Cannon_Beacon : public ScriptImpClass {
+	void Destroyed(GameObject *obj);
+};
\ No newline at end of file
diff -uwr source/scripts/tcw_powerup.cpp 4.0/source/scripts/tcw_powerup.cpp
--- source/scripts/tcw_powerup.cpp	2011-08-16 08:01:10.000000000 +0800
+++ 4.0/source/scripts/tcw_powerup.cpp	2011-10-14 22:25:11.421875000 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -152,5 +152,4 @@
 }
 
 
-
 ScriptRegistrant<tcw_POW_PickupSounds> tcw_POW_PickupSounds_Registrant("tcw_POW_PickupSounds","");
\ No newline at end of file
diff -uwr source/scripts/tcw_powerup.h 4.0/source/scripts/tcw_powerup.h
--- source/scripts/tcw_powerup.h	2011-08-16 08:01:10.000000000 +0800
+++ 4.0/source/scripts/tcw_powerup.h	2011-10-14 22:27:32.081054600 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -11,6 +11,7 @@
 	with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 class tcw_POW_PickupSounds : public ScriptImpClass {
 	void Custom(GameObject *obj, int message, int param, GameObject *sender);
diff -uwr source/scripts/tcw_technology.cpp 4.0/source/scripts/tcw_technology.cpp
--- source/scripts/tcw_technology.cpp	2011-08-16 08:01:10.000000000 +0800
+++ 4.0/source/scripts/tcw_technology.cpp	2011-10-14 22:25:11.492187500 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -22,7 +22,7 @@
 	allowpokegdi = true;
 	researching_composit_armor_upgrade = false;
 	researched_composit_armor_upgrade = false;
-	research_composit_armor_cost = 6000.0f;
+	research_composit_armor_cost = 2000.0f;
 	research_composit_armor_fund = 0.0f;
 }
 void tcw_Research_Composit_Armor::Poked(GameObject *obj, GameObject *poker)
@@ -31,26 +31,26 @@
 	{
 		if (Commands->Get_Player_Type(poker) == 1)
 		{
-			if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Armory")))
+			if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Armory_Building")))
 			{
 				if (!researching_composit_armor_upgrade)
 				{
 					if (!researched_composit_armor_upgrade)
 					{
-						if (research_composit_armor_fund < 6000.0f)
+						if (research_composit_armor_fund < 2000.0f)
 						{
-							if (Commands->Get_Money(poker) >= 500.0f)
+							if (Commands->Get_Money(poker) >= 250.0f)
 							{
-								research_composit_armor_fund += 500.0f;
-								Commands->Give_Money(poker,-500.0f,false);
+								research_composit_armor_fund += 250.0f;
+								Commands->Give_Money(poker,-250.0f,false);
 								char addedfunds[250];
-								sprintf(addedfunds,"%s added $500 to the Composite Armor Upgrade. Current Funds: %g/%g",Get_Player_Name(poker),research_composit_armor_fund,research_composit_armor_cost);
+								sprintf(addedfunds,"%s added $250 to the Composite Armor Upgrade. Current Funds: %g/%g",Get_Player_Name(poker),research_composit_armor_fund,research_composit_armor_cost);
 								Send_Message_Team(1,255,204,0,addedfunds);
 								
-								if (research_composit_armor_fund == 6000.0f)
+								if (research_composit_armor_fund == 2000.0f)
 								{
 									researching_composit_armor_upgrade = true;
-									Commands->Start_Timer(obj,this,60.0f,10001);
+									Commands->Start_Timer(obj,this,20.0f,10001);
 									Create_2D_WAV_Sound_Team("gdi_tech_upgrade_in_progress.wav",1);
 									Send_Message_Team(1,255,204,0,"Upgrade in progress: Composite Armor.");
 									allowpokegdi = false;
@@ -87,7 +87,7 @@
 {
 	if (number == 10001)
 	{
-		if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Armory")))
+		if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Armory_Building")))
 		{
 			Vector3 pos; pos.Z = 999.0f; pos.Y = 999.0f; pos.X = 999.0f;
 			GameObject *compositarmor = Commands->Create_Object("TCW_Tech_Composit_Armor_Available",pos);
@@ -124,4 +124,165 @@
 	Auto_Save_Variable(&allowpokegdi,sizeof(allowpokegdi),5);
 }
 
+void tcw_hide_show_tech::Created(GameObject *obj)
+{
+	//gdi wf steal-able tech:
+	Hide_Preset_By_Name(0,"TCW_Nod_Predator_Tank",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Pitbull",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_GDI_Harvester_Player",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_APC",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Mammoth_Tank",true);
+
+	//nod wf steal-able tech:
+	Hide_Preset_By_Name(1,"TCW_GDI_Attack_Bike",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Flame_Tank",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Nod_Harvester_Player",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Raider_Buggy",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Scorpion_Tank",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Stealth_Tank",true);
+}
+
+
+////Start tech stealing zones
+
+void tcw_steal_tech_zone_gwf::Entered(GameObject *obj, GameObject *enter)
+{
+	if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_War_Factory")))
+	{
+		if (Commands->Is_A_Star(enter))
+		{
+			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur_Low") == 0) )
+			{
+				if (!Get_Vehicle(enter))
+				{
+					Attach_Script_Once(enter,"tcw_i_am_stealing_tech","1");
+				}
+			}
+		}
+	}
+}
+void tcw_steal_tech_zone_gwf::Exited(GameObject *obj, GameObject *exit)
+{
+	if (Commands->Is_A_Star(exit))
+	{
+		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur_Low") == 0) )
+		{
+			Remove_Script(exit,"tcw_i_am_stealing_tech");
+		}
+	}
+}
+
+void tcw_steal_tech_zone_nwf::Entered(GameObject *obj, GameObject *enter)
+{
+	if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_Nod_War_Factory")))
+	{
+		if (Commands->Is_A_Star(enter))
+		{
+			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer_Low") == 0) )
+			{
+				if (!Get_Vehicle(enter))
+				{
+					Attach_Script_Once(enter,"tcw_i_am_stealing_tech","2");
+				}
+			}
+		}
+	}
+}
+void tcw_steal_tech_zone_nwf::Exited(GameObject *obj, GameObject *exit)
+{
+	if (Commands->Is_A_Star(exit))
+	{
+		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer_Low") == 0) )
+		{
+			Remove_Script(exit,"tcw_i_am_stealing_tech");
+		}
+	}
+}
+
+////End tech stealing zones
+
+void tcw_i_am_stealing_tech::Created(GameObject *obj)
+{
+	int building = Get_Int_Parameter("Building");
+	if (building == 1)//nod stealing gdi wf
+	{
+		Commands->Start_Timer(obj,this,15.0f,779901);//start stealing from the gdi wf
+		char stealermsg[250];
+		sprintf(stealermsg,"%s is stealing technology from the GDI War Factory.",Get_Player_Name(obj));
+		Send_Message_Team(0,255,0,0,stealermsg);
+		Create_2D_WAV_Sound_Team("building_capture.wav",0);
+	}
+	else if (building == 2)//gdi stealing nod wf
+	{
+		Commands->Start_Timer(obj,this,15.0f,779902);//start stealing from the gdi wf
+		char stealermsg[250];
+		sprintf(stealermsg,"%s is stealing technology from the Nod Weapons Factory.",Get_Player_Name(obj));
+		Send_Message_Team(1,255,204,0,stealermsg);
+		Create_2D_WAV_Sound_Team("building_capture.wav",1);
+	}
+}
+void tcw_i_am_stealing_tech::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 779901)//nod stole tech from gdi wf
+	{
+		if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
+		{
+			Commands->Select_Weapon(obj,"TCW_Weapon_Pistol");
+			Remove_Weapon(obj,"TCW_Weapon_Repairgun_Advanced");
+					
+			Hide_Preset_By_Name(0,"TCW_Nod_Predator_Tank",false);
+			Hide_Preset_By_Name(0,"TCW_Nod_Pitbull",false);
+			Hide_Preset_By_Name(0,"TCW_Nod_GDI_Harvester_Player",false);
+			Hide_Preset_By_Name(0,"TCW_Nod_APC",false);
+			Hide_Preset_By_Name(0,"TCW_Nod_Mammoth_Tank",false);
+
+			char stealmsg[250];
+			sprintf(stealmsg,"%s has stolen technology from the GDI War Factory",Get_Player_Name(obj));
+			Send_Message_Team(0,255,0,0,stealmsg);
+			Send_Message_Team(0,255,0,0,"New technology acquired.");
+			Create_2D_WAV_Sound_Team("nod_new_tech_acquired.wav",0);
+		}
+		else
+		{
+			Send_Message_Player(obj,255,0,0,"To steal technology you need a FULL AMMO Repair Gun.");
+			Destroy_Script();
+		}
+	}
+
+	if (number == 779902)//gdi stole tech from nod wf
+	{
+		if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
+		{
+			Commands->Select_Weapon(obj,"TCW_Weapon_Pistol");
+			Remove_Weapon(obj,"TCW_Weapon_Repairgun_Advanced");
+					
+			Hide_Preset_By_Name(1,"TCW_GDI_Attack_Bike",false);
+			Hide_Preset_By_Name(1,"TCW_GDI_Flame_Tank",false);
+			Hide_Preset_By_Name(1,"TCW_GDI_Nod_Harvester_Player",false);
+			Hide_Preset_By_Name(1,"TCW_GDI_Raider_Buggy",false);
+			Hide_Preset_By_Name(1,"TCW_GDI_Scorpion_Tank",false);
+			Hide_Preset_By_Name(1,"TCW_GDI_Stealth_Tank",false);
+
+			char stealmsg[250];
+			sprintf(stealmsg,"%s has stolen technology from the Nod Weapons Factory",Get_Player_Name(obj));
+			Send_Message_Team(1,255,204,0,stealmsg);
+			Send_Message_Team(1,255,204,0,"New technology acquired.");
+			Create_2D_WAV_Sound_Team("gdi_new_tech_acquired.wav",1);
+		}
+		else
+		{
+			Send_Message_Player(obj,255,204,0,"To steal technology you need a FULL AMMO Repair Gun.");
+			Destroy_Script();
+		}
+	}
+}
+
+
+ScriptRegistrant<tcw_steal_tech_zone_nwf> tcw_steal_tech_zone_nwf_Registrant("tcw_steal_tech_zone_nwf","");
+ScriptRegistrant<tcw_steal_tech_zone_gwf> tcw_steal_tech_zone_gwf_Registrant("tcw_steal_tech_zone_gwf","");
+ScriptRegistrant<tcw_i_am_stealing_tech> tcw_i_am_stealing_tech_Registrant("tcw_i_am_stealing_tech","Building=1:int");
+ScriptRegistrant<tcw_hide_show_tech> tcw_hide_show_tech_Registrant("tcw_hide_show_tech","");
 ScriptRegistrant<tcw_Research_Composit_Armor> tcw_Research_Composit_Armor_Registrant("tcw_Research_Composit_Armor","");
\ No newline at end of file
+
+
+
diff -uwr source/scripts/tcw_technology.h 4.0/source/scripts/tcw_technology.h
--- source/scripts/tcw_technology.h	2011-08-16 08:01:10.000000000 +0800
+++ 4.0/source/scripts/tcw_technology.h	2011-10-14 22:27:32.105468700 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -11,6 +11,7 @@
 	with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 class tcw_Research_Composit_Armor : public ScriptImpClass {
 	void Created(GameObject *obj);
@@ -24,3 +25,23 @@
 	float research_composit_armor_fund;
 };
 
+class tcw_hide_show_tech : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+
+class tcw_steal_tech_zone_gwf : public ScriptImpClass {
+	void Entered(GameObject *obj, GameObject *enter);
+	void Exited(GameObject *obj, GameObject *exit);
+};
+
+class tcw_steal_tech_zone_nwf : public ScriptImpClass {
+	void Entered(GameObject *obj, GameObject *enter);
+	void Exited(GameObject *obj, GameObject *exit);
+};
+
+
+class tcw_i_am_stealing_tech : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
+};
\ No newline at end of file
diff -uwr source/scripts/tcw_vehicle.cpp 4.0/source/scripts/tcw_vehicle.cpp
--- source/scripts/tcw_vehicle.cpp	2011-09-03 08:30:06.000000000 +0800
+++ 4.0/source/scripts/tcw_vehicle.cpp	2011-10-14 22:25:11.452148400 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -42,6 +42,24 @@
 			Send_Message_Team(1,255,204,0,"APC ready for combat.");
 		}
 	}
+	if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_APC") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_apc_1.wav",0);
+			Send_Message_Team(0,255,0,0,"APC ready for combat.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_apc_2.wav",0);
+			Send_Message_Team(0,255,0,0,"APC what's the plan.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_apc_1.wav",0);
+			Send_Message_Team(0,255,0,0,"APC ready for combat.");
+		}
+	}
 	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) )
 	{
 		if (random == 1)
@@ -60,6 +78,24 @@
 			Send_Message_Team(1,255,204,0,"I'm ready to go, which way is the tiberium?");
 		}
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_GDI_Harvester_Player") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_1.wav",0);
+			Send_Message_Team(0,255,0,0,"Let's get to that tib-zone.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_1.wav",0);
+			Send_Message_Team(0,255,0,0,"Let's get to that tib-zone.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_2.wav",0);
+			Send_Message_Team(0,255,0,0,"I'm ready to go, which way is the tiberium?");
+		}
+	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Juggernaut") == 0)
 	{
 		if (random == 1)
@@ -97,6 +133,24 @@
 		}
 		Commands->Start_Timer(obj,this,1.0f,1008);//railgun tech check
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Mammoth_Tank") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_1.wav",0);
+			Send_Message_Team(0,255,0,0,"Mammoth Tank waiting orders.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_2.wav",0);
+			Send_Message_Team(0,255,0,0,"Mammoth Tank ready.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_3.wav",0);
+			Send_Message_Team(0,255,0,0,"Mammoth Tank assembled.");
+		}
+	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0)
 	{
 		if (random == 1)
@@ -115,22 +169,22 @@
 			Send_Message_Team(1,255,204,0,"Pitbull looking for some action.");
 		}
 	}
-	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Predator_Tank") == 0)
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0)
 	{
 		if (random == 1)
 		{
-			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",1);
-			Send_Message_Team(1,255,204,0,"Predator rolling out.");
+			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_1.wav",0);
+			Send_Message_Team(0,255,0,0,"Pitbull ready for action.");
 		}
 		else if (random == 2)
 		{
-			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",1);
-			Send_Message_Team(1,255,204,0,"Predator rolling out.");
+			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_1.wav",0);
+			Send_Message_Team(0,255,0,0,"Pitbull ready for action.");
 		}
 		else if (random == 3)
 		{
-			Create_2D_WAV_Sound_Team("purchase_gdi_predator_2.wav",1);
-			Send_Message_Team(1,255,204,0,"Predator crew ready to roll.");
+			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_2.wav",0);
+			Send_Message_Team(0,255,0,0,"Pitbull looking for some action.");
 		}
 	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Predator_Tank") == 0)
@@ -151,7 +205,24 @@
 			Send_Message_Team(1,255,204,0,"Predator crew ready to roll.");
 		}
 	}
-
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Predator_Tank") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",0);
+			Send_Message_Team(0,255,0,0,"Predator rolling out.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",0);
+			Send_Message_Team(0,255,0,0,"Predator rolling out.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_gdi_predator_2.wav",0);
+			Send_Message_Team(0,255,0,0,"Predator crew ready to roll.");
+		}
+	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Attack_Bike") == 0)
 	{
 		if (random == 1)
@@ -170,6 +241,24 @@
 			Send_Message_Team(0,255,0,0,"Let's go for a hunt.");
 		}
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Attack_Bike") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_1.wav",1);
+			Send_Message_Team(1,255,204,0,"This bike's ready.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_2.wav",1);
+			Send_Message_Team(1,255,204,0,"Let's go for a hunt.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_2.wav",1);
+			Send_Message_Team(1,255,204,0,"Let's go for a hunt.");
+		}
+	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Raider_Buggy") == 0)
 	{
 		if (random == 1)
@@ -188,6 +277,24 @@
 			Send_Message_Team(0,255,0,0,"Let's go on a raid.");
 		}
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Raider_Buggy") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_1.wav",1);
+			Send_Message_Team(1,255,204,0,"Raider here.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_1.wav",1);
+			Send_Message_Team(1,255,204,0,"Raider here.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_2.wav",1);
+			Send_Message_Team(1,255,204,0,"Let's go on a raid.");
+		}
+	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Scorpion_Tank") == 0)
 	{
 		if (random == 1)
@@ -206,6 +313,24 @@
 			Send_Message_Team(0,255,0,0,"Scorpion ready for battle.");
 		}
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Scorpion_Tank") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_1.wav",1);
+			Send_Message_Team(1,255,204,0,"The scorpion's ready.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_2.wav",1);
+			Send_Message_Team(1,255,204,0,"Scorpion ready for battle.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_2.wav",1);
+			Send_Message_Team(1,255,204,0,"Scorpion ready for battle.");
+		}
+	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Stealth_Tank") == 0)
 	{
 		if (random == 1)
@@ -224,6 +349,24 @@
 			Send_Message_Team(0,255,0,0,"Stealth tank clear for combat.");
 		}
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Stealth_Tank") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",1);
+			Send_Message_Team(1,255,204,0,"Stealth tank clear for combat.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",1);
+			Send_Message_Team(1,255,204,0,"Stealth tank clear for combat.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",1);
+			Send_Message_Team(1,255,204,0,"Stealth tank clear for combat.");
+		}
+	}
 	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Flame_Tank") == 0)
 	{
 		if (random == 1)
@@ -242,6 +385,24 @@
 			Send_Message_Team(0,255,0,0,"Do not toy with the power of the flame.");
 		}
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Flame_Tank") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_1.wav",1);
+			Send_Message_Team(1,255,204,0,"The flames will rise.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_1.wav",1);
+			Send_Message_Team(1,255,204,0,"The flames will rise.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_2.wav",1);
+			Send_Message_Team(1,255,204,0,"Do not toy with the power of the flame.");
+		}
+	}
 	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || 
 			  (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) )
 	{
@@ -261,6 +422,24 @@
 			Send_Message_Team(0,255,0,0,"Tiberium is power.");
 		}
 	}
+	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0)
+	{
+		if (random == 1)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_harvester_1.wav",1);
+			Send_Message_Team(1,255,204,0,"It is time for a harvest.");
+		}
+		else if (random == 2)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_harvester_1.wav",1);
+			Send_Message_Team(1,255,204,0,"It is time for a harvest.");
+		}
+		else if (random == 3)
+		{
+			Create_2D_WAV_Sound_Team("purchase_nod_harvester_2.wav",1);
+			Send_Message_Team(1,255,204,0,"Tiberium is power.");
+		}
+	}
 }
 void tcw_vehicle::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
@@ -271,18 +450,15 @@
 		{
 			Commands->Start_Timer(obj,this,0.5f,100100);
 		}
-		if (Commands->Get_Player_Type(obj) == 1)
-		{
-			if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0)
+		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0) )
 			{
 				Commands->Start_Timer(obj,this,5.0f,1004);
 				triggerstealthdetection = true;
 			}
 		}
-	}
 	else if (message == CUSTOM_EVENT_VEHICLE_EXITED)
 	{
-		if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0)
+		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0) )
 		{
 			triggerstealthdetection = false;
 		}
@@ -336,11 +512,17 @@
 		Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow",1004,1,0);
 		Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow_Low",1004,1,0);
 		Send_Custom_Event_To_Object(obj,"TCW_Nod_Stealth_Tank",1004,1,0);
-		Send_Custom_Event_To_Object(obj,"TCW_Nod_Harvester_Player",1004,1,0);
+		Send_Custom_Event_To_Object(obj,"TCW_GDI_Stealth_Tank",1004,1,0);
 		Send_Custom_Event_To_Object(obj,"TCW_Nod_Harvester",1004,1,0);
+		Send_Custom_Event_To_Object(obj,"TCW_Nod_Harvester_Player",1004,1,0);
+		Send_Custom_Event_To_Object(obj,"TCW_GDI_Nod_Harvester_Player",1004,1,0);
+		Send_Custom_Event_To_Object(obj,"TCW_GDI_Sniper",1004,1,0);
+		Send_Custom_Event_To_Object(obj,"TCW_GDI_Sniper_Low",1004,1,0);
+		Send_Custom_Event_To_Object(obj,"TCW_Nod_Commando",1004,1,0);
+		Send_Custom_Event_To_Object(obj,"TCW_Nod_Commando_Low",1004,1,0);
 		if (triggerstealthdetection)
 		{
-			if (Commands->Get_Player_Type(obj) == 1)
+			if ( (Commands->Get_Player_Type(obj) == 0) || (Commands->Get_Player_Type(obj) == 1) )
 			{
 				Commands->Start_Timer(obj,this,5.0f,1004);
 			}
@@ -380,7 +562,8 @@
 	if (Commands->Get_Player_Type(obj) == 0)
 	{
 		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || 
-			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) )
+			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) || 
+			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_GDI_Harvester_Player") == 0) )
 		{
 			Create_2D_WAV_Sound_Team("nod_harvester_lost.wav",0);
 			Send_Message_Team(0,255,0,0,"Harvester lost.");
@@ -394,7 +577,8 @@
 	else if (Commands->Get_Player_Type(obj) == 1)
 	{
 		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester") == 0) || 
-			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) )
+			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) || 
+			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) )
 		{
 			Create_2D_WAV_Sound_Team("gdi_harvester_lost.wav",1);
 			Send_Message_Team(1,255,204,0,"Harvester lost.");
@@ -409,7 +593,8 @@
 void tcw_vehicle::Damaged(GameObject *obj, GameObject *damager, float damage)
 {
 	if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester") == 0) || 
-		 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) )
+		 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) || 
+		 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) )
 	{
 		if (playdamage)
 		{
@@ -423,7 +608,8 @@
 		}
 	}
 	else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || 
-			  (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) )
+			  (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0)  || 
+			  (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_GDI_Harvester_Player") == 0) )
 	{
 		if (playdamage)
 		{
@@ -445,5 +631,32 @@
 	Auto_Save_Variable(&playdamage,sizeof(playdamage),4);
 }
 
+void tcw_vehexit_killtimer::Created(GameObject *obj)
+{
+	timerid = Commands->Get_ID(obj);
+}
+void tcw_vehexit_killtimer::Custom(GameObject *obj, int message, int param, GameObject *sender)
+{
+	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
+	{
+		Commands->Start_Timer(obj,this,60.0f,Commands->Get_ID(obj));
+	}
+}
+void tcw_vehexit_killtimer::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == timerid)
+	{
+		if (!Get_Vehicle_Driver(obj))
+		{
+			Commands->Destroy_Object(obj);
+		}
+	}
+}
+void tcw_vehexit_killtimer::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&timerid,sizeof(timerid),1);
+}
+
 
+ScriptRegistrant<tcw_vehexit_killtimer> tcw_vehexit_killtimer_Registrant("tcw_vehexit_killtimer","");
 ScriptRegistrant<tcw_vehicle> tcw_vehicle_Registrant("tcw_vehicle","");
\ No newline at end of file
diff -uwr source/scripts/tcw_vehicle.h 4.0/source/scripts/tcw_vehicle.h
--- source/scripts/tcw_vehicle.h	2011-08-16 08:01:10.000000000 +0800
+++ 4.0/source/scripts/tcw_vehicle.h	2011-10-15 12:39:38.283203100 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -11,7 +11,7 @@
 	with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
+#pragma once
 
 class tcw_vehicle : public ScriptImpClass {
 	void Created(GameObject *obj);
@@ -27,3 +27,10 @@
 	bool is_railgun_available;
 };
 
+class tcw_vehexit_killtimer : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
+	void Timer_Expired(GameObject *obj, int number);
+	public: void Register_Auto_Save_Variables();
+	int timerid;
+};
Only in 4.0/source/scripts: tcw_zone.cpp
Only in 4.0/source/scripts: tcw_zone.h
diff -uwr source/scripts/tda.cpp 4.0/source/scripts/tda.cpp
--- source/scripts/tda.cpp	2010-04-14 10:13:24.000000000 +0800
+++ 4.0/source/scripts/tda.cpp	2011-10-11 23:12:49.508789000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by Tom "Dante" Anderson
-	Copyright 2010 Tom "Dante" Anderson, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/tda.h 4.0/source/scripts/tda.h
--- source/scripts/tda.h	2010-04-14 10:13:28.000000000 +0800
+++ 4.0/source/scripts/tda.h	2011-10-14 22:27:32.095703100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by Tom "Dante" Anderson
-	Copyright 2010 Tom "Dante" Anderson, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class TDA_Stealth_Armor:public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Timer_Expired(GameObject *obj,int timer_id);
